# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class ActionParameterDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'type': 'str',
        'multi_valued': 'bool',
        'mandatory': 'bool',
        'display_label': 'str',
        'parameter_constraint_name': 'str'
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'multi_valued': 'multiValued',
        'mandatory': 'mandatory',
        'display_label': 'displayLabel',
        'parameter_constraint_name': 'parameterConstraintName'
    }

    def __init__(self, name=None, type=None, multi_valued=None, mandatory=None, display_label=None, parameter_constraint_name=None, _configuration=None):  # noqa: E501
        """ActionParameterDefinition - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._type = None
        self._multi_valued = None
        self._mandatory = None
        self._display_label = None
        self._parameter_constraint_name = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if type is not None:
            self.type = type
        if multi_valued is not None:
            self.multi_valued = multi_valued
        if mandatory is not None:
            self.mandatory = mandatory
        if display_label is not None:
            self.display_label = display_label
        if parameter_constraint_name is not None:
            self.parameter_constraint_name = parameter_constraint_name

    @property
    def name(self):
        """Gets the name of this ActionParameterDefinition.  # noqa: E501


        :return: The name of this ActionParameterDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ActionParameterDefinition.


        :param name: The name of this ActionParameterDefinition.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this ActionParameterDefinition.  # noqa: E501


        :return: The type of this ActionParameterDefinition.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ActionParameterDefinition.


        :param type: The type of this ActionParameterDefinition.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def multi_valued(self):
        """Gets the multi_valued of this ActionParameterDefinition.  # noqa: E501


        :return: The multi_valued of this ActionParameterDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._multi_valued

    @multi_valued.setter
    def multi_valued(self, multi_valued):
        """Sets the multi_valued of this ActionParameterDefinition.


        :param multi_valued: The multi_valued of this ActionParameterDefinition.  # noqa: E501
        :type: bool
        """

        self._multi_valued = multi_valued

    @property
    def mandatory(self):
        """Gets the mandatory of this ActionParameterDefinition.  # noqa: E501


        :return: The mandatory of this ActionParameterDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._mandatory

    @mandatory.setter
    def mandatory(self, mandatory):
        """Sets the mandatory of this ActionParameterDefinition.


        :param mandatory: The mandatory of this ActionParameterDefinition.  # noqa: E501
        :type: bool
        """

        self._mandatory = mandatory

    @property
    def display_label(self):
        """Gets the display_label of this ActionParameterDefinition.  # noqa: E501


        :return: The display_label of this ActionParameterDefinition.  # noqa: E501
        :rtype: str
        """
        return self._display_label

    @display_label.setter
    def display_label(self, display_label):
        """Sets the display_label of this ActionParameterDefinition.


        :param display_label: The display_label of this ActionParameterDefinition.  # noqa: E501
        :type: str
        """

        self._display_label = display_label

    @property
    def parameter_constraint_name(self):
        """Gets the parameter_constraint_name of this ActionParameterDefinition.  # noqa: E501


        :return: The parameter_constraint_name of this ActionParameterDefinition.  # noqa: E501
        :rtype: str
        """
        return self._parameter_constraint_name

    @parameter_constraint_name.setter
    def parameter_constraint_name(self, parameter_constraint_name):
        """Sets the parameter_constraint_name of this ActionParameterDefinition.


        :param parameter_constraint_name: The parameter_constraint_name of this ActionParameterDefinition.  # noqa: E501
        :type: str
        """

        self._parameter_constraint_name = parameter_constraint_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ActionParameterDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActionParameterDefinition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ActionParameterDefinition):
            return True

        return self.to_dict() != other.to_dict()
